//
//  AGShortcutPickerView.h
//  AGShortcutPickerView
//
//  Created by Seth Willits on 9/30/06.
//  Copyright 2006 Araelium Group. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "AGShortcut.h"

NS_ASSUME_NONNULL_BEGIN

@interface AGShortcutPickerView : NSControl {
	
	// Behavior
	BOOL mIsStrict;
	AGShortcut * mShortcut;
	id target;
	SEL action;
		
	// Drawing
	NSTextFieldCell * mTextCell;
	NSButtonCell * mClearCell;
	BOOL mShouldDrawFocusRing;
	NSResponder * mLastResponder;
	BOOL mDidDrawFocusRing;
}


@property (readwrite, strong, nullable) AGShortcut * shortcut;

// Only allows shortcuts that are Function Keys, or has a modifier
@property (nonatomic, readwrite) BOOL isStrict;


@end

NS_ASSUME_NONNULL_END
